function y = check_params(  f_carrier,f_clk,CLK_DIV, N_pat,f_mod,N,SOSR,IOSR );

if (abs((f_clk/f_carrier)-round(f_clk/f_carrier))>0)
    error('Carrier frequency is not an integer multiple of the master clock frequency')
end
if CLK_DIV > 16
    error('Clock Divider CLK_DIV is greater than 16')
end  
if N_pat > 1024
    error('Length of Pattern N_pat larger than 1024')
end
if N_pat < 500
    warning('Length of Pattern N_pat less than 500.  Carrier Signal may be excessively noisy.')
end
if mod(N,0.5)>0
    error('Value N is not an integer multiple of 0.5.  Integration will not be coherent')   
end
if SOSR>256
    error('Oversampling Ratio SOSR is larger than 256.')   
end
if abs(round(IOSR)-IOSR) > 0 | IOSR > 128 
    error('IOSR must be an integer between 1 and 128')
end
