function y = sigpat(N_pattern)
%This function calculates the binary pattern to be programmed into
%the Pattern Register.  The length of the signal is passed by the 
%N_pattern variable.
if N_pattern < 10 | N_pattern > 1024
    error('Signal Pattern length is out of range.')
end
y = [zeros(1,1024)];
dec_word = [zeros(64,1)];
bin_word = [zeros(64,1)];
z1 = 0;z2 = 0;index = 1:N_pattern;
Sine_wave = 2.0*sin(2*pi*(index)/N_pattern);
for n=1:1:N_pattern             %create del-sig data through recursive algorithm
    if z2>0
        y(n)=1;
        ref=2.5;
    else  
        y(n)=0;
        ref=-2.5;
    end
    z2 = z2 + 1/2.0 * z1 - 1/5.0 * ref;
    z1 = z1 + 1/5.0 * Sine_wave(n)- 1/5.0 * ref;
end

try
    filepath = mfilename('fullpath');   %create binary data output file
    bin_filepath = strcat(filepath,'_bin.txt'); 
    hex_filepath = strcat(filepath,'_hex.txt');     %create hex. data output file
    fid1=fopen(hex_filepath,'wt');
    fid2=fopen(bin_filepath,'wt');
    disp 'Output files:'
    disp(hex_filepath)
    disp(bin_filepath)
catch
    try
        filepath = strcat(tempdir, 'sigpat');
        bin_filepath = strcat(filepath,'_bin.txt'); 
        hex_filepath = strcat(filepath,'_hex.txt');     %create hex. data output file
        fid1=fopen(hex_filepath,'wt');        
        fid2=fopen(bin_filepath,'wt');        
        disp 'Output file written to:'
        disp(hex_filepath)
        disp(bin_filepath)
    catch
        disp 'Error writing output files.'
        return
    end
end
i=1;
fprintf(fid1,'%s\n',dec2hex(N_pattern));   % write length of pattern for control
fprintf(fid2,'%s\n',dec2bin(N_pattern));   % register bits PC
for n=64:-1:1
    for m=0:1:15
        dec_word(i) = dec_word(i) + y((m+1)+(n-1)*16)*2^m;  %save data for hex. ouput file
        fprintf(fid2,'%d',y((16-m)+(n-1)*16));   %write to binary data output file
    end
    fprintf(fid2,'\n');
    i=i+1;
end

fprintf(fid1,'%4X\n',dec_word);                  %write to hex. data output file
fclose(fid2); 
fclose(fid1);                                 
return
